<?php

Class AboutusAction extends CommonAction {

        public function saveTag($vo,$list,$module) {
            if (!empty($vo) && !empty($list)) {
                $Tag = M("Tag");
                $Tagged = M("Tagged");
                $tags = explode(' ',$vo['tags']);
                foreach($tags as $key=>$val) {
                    $val = trim($val);
                    if (!empty($val)) {
                       // 记录已经存在的标签
                       $map["module"] = "Aboutus";
                       $map["name"] = $val;
                       $tagg = $Tag->where($map)->find();
                        if ($tagg) {
							$tagId = $tagg['id'];
                            $Tag->setInc('count','id='.$tagg["id"]);
                        }else {
                            $t = array();
                            $t["name"] = $val;
                            $t["count"] = 1;
                            $t["module"] = $module;
                            $result = $Tag->add($t);
                            $tagId = $result;
                       }
                    }
					//记录tag信息
					$t = array();
					$t["module"] = $module;
					$t["recordId"] = $list;
					$t["tagTime"] = time();
					$t["tagId"] = $tagId;
					$Tagged->add($t);
                }
            }
        }
       // 保存日志的标签和附件
	public function _trigger($vo,$list) {
		if(ACTION_NAME=='insert') {
            $dao = M("Attach");
			$attach['verify'] = 0;
			$attach['recordId'] = $list;
            $dao->where("verify='".$_SESSION["attach_verify"]."'")->save($attach);
		}
		$this->saveTag($vo,$list,"Aboutus");
	}


   public function insert() {
		$Aboutus = D("Aboutus");
		if ($vo = $Aboutus->create()) {
			$list = $Aboutus->add();
			if ($list) {
				//数据保存触发器
				if (method_exists($this,'_trigger')) {
					$this->_trigger($vo,$list);
				}
				$this->success("操作成功");
			}else {
				$this->error("操作失败");
			}
		}else {
			$this->error($Aboutus->getError());
		}
	}
        
        public function show() {
            
            $this->getAttach();
            $id = $_REQUEST["id"];
            if (!empty($id)) {
               $Aboutus = D("AboutusView");
               $result = $Aboutus->where('Aboutus.id='.$id)->find();  // 这里为什么用select()就读不出来
               if ($result) {
                   $this->assign('vo', $result);
               }else {
                   $this->redirect('index');
                   return ;
               }
            }else {
                $this->redirect('index');
            }
            $this->display();
            return ;
        }

        public function _after_show() {
            $Aboutus = D("Aboutus");
            $aboutus = $this->get('vo');
            // 阅读计数
            $id	= $aboutus["id"];
            if(!isset($_SESSION['aboutus_read_count_'.$id])) {
		$Aboutus->setInc('readCount',"id=".$id);
		$_SESSION['aboutus_read_count_'.$id] = true;
            }
        }

        public function _before_add() {
                $verify = build_verify(8);
                $_SESSION['attach_verify'] = $verify;
                $this->assign('verify',$verify);
        }
        public function add() {
            $this->display();
        }
	public function index() {
		
            $Aboutus = D("AboutusView");
            $count = $Aboutus->count();
            $listRows = 3;
            //$fields	= 'id,title,categoryId,cTime,readCount,commentCount,content,tags';
            import("@.ORG.Page");
            $p = new Page($count, $listRows);
            $p->setConfig("header", "篇文章");
            $this->assign("mode", $mode);
            $list =  $Aboutus->order("cTime desc")->limit($p->firstRow.','.$p->listRows)->select();
            $page = $p->show();
            $this->assign("list", $list);
            $this->assign("count", $count);
            $this->assign("page", $page);

            //统计数据
            $Aboutus = M("Aboutus");
            $stat = array();
            $stat["beginTime"] = $Aboutus->min('cTime');
            $stat["aboutusCount"] = $Aboutus->where("status=1")->count();
            $stat["readCount"] = $Aboutus->where("status=1")->sum("readCount");
            
            $this->assign($stat);

            $this->display();
	}

          public function tag() {
            $Tag = M("Tag");
            if(!empty($_GET['name'])) {
                $name = trim($_REQUEST['name']);
                $list = $Tag->where("module='Aboutus' and name='$name'")->field('id,count')->find();
				$tagId = $list['id'];
				$count = $list['count'];
				import("@.ORG.Page");
				$listRows = 5;
				$fields	= 'a.id,a.userId,a.categoryId,a.cTime,a.readCount,a.commentCount,a.title,c.title as category';
				$p = new Page($count,$listRows);
				$p->setConfig('header' ,'篇文章 ');
				$dao = D("Aboutus");
				$list = $dao->query("select ".$fields." from ".C('DB_PREFIX').'aboutus as a,'.C('DB_PREFIX').'tagged as b, '.C('DB_PREFIX').'category as c where b.tagId  in ('.$tagId.') and a.categoryId= c.id and a.status=1  and a.id=b.recordId order by a.id desc limit '.$p->firstRow.','.$p->listRows);
				if($list) {
                    $page = $p->show();
                    $this->assign("page", $page);
                    $this->assign('list',$list);
                }
                $this->assign('tag',$name);
                $this->assign("count",$count);
            }else {
                $list = $Tag->where("module='Aboutus'")->findAll();
                //dump($list);
                $this->assign('tags',$list);
            }
            $this->display();
        }

        public function edit() {
            $Aboutus = M("Aboutus");
            $id = $_REQUEST['id'];
            $aboutus = $Aboutus->where('id='.$id)->find();
            //dump($aboutus);
            if($aboutus) {
                $this->getAttach();
                $this->assign('vo',$aboutus);
                $this->display();
            }else{
                $this->redirect('Aboutus/index');
            }
	}
        public function update() {
            $model = D("Aboutus");
            $vo = $model->create('','edit');
            if(!$vo) {
                $this->error($model->getError());
            }
            $id	= is_array($vo)?$vo[$model->getPk()]:$vo->{$model->getPk()};
            $result  = $model->save($vo);
            if($result) {

                //数据保存触发器
                if(method_exists($this,'_trigger')) {
                    $this->_trigger($vo, $result);
                }

                if(!empty($_FILES)) {//如果有文件上传
                    //执行默认上传操作
                    //保存附件信息到数据库
                   $this->_upload(MODULE_NAME,$result);
                }

                //成功提示
                $this->success("操作成功！");
            }else {
                //错误提示
                $this->error($model->getError());
            }
        }
        	  // 删除数据 
    public function delete() { 
        if(!empty($_POST['id'])) { 
            $Aboutus    =    M("Aboutus"); 
            $result    =    $Aboutus->delete($_POST['id']); 
            if(false !== $result) { 
                $this->ajaxReturn($_POST['id'],'删除成功！',1); 
            }else{ 
                $this->error('删除出错！'); 
            } 
        }else{ 
            $this->error('删除项不存在！'); 
        } 
    } 

}
?>